=== modified file 'lib/launchpad_loggerhead/app.py'
--- lib/launchpad_loggerhead/app.py	2011-10-26 16:21:36 +0000
+++ lib/launchpad_loggerhead/app.py	2011-11-16 15:38:18 +0000
@@ -238,8 +238,12 @@
             if not os.path.isdir(cachepath):
                 os.makedirs(cachepath)
             self.log.info('branch_url: %s', branch_url)
-            branch_api_url = urlparse.urljoin(
-                config.appserver_root_url('api'), 'devel', branch_name)
+            base_api_url = config.appserver_root_url('api')
+            branch_api_url = '%s/%s/%s' % (
+                base_api_url,
+                'devel',
+                branch_name,
+                )
             self.log.info('branch_api_url: %s', branch_api_url)
             req = urllib2.Request(branch_api_url)
             private = False
@@ -247,16 +251,19 @@
                 # We need to determine if the branch is private
                 response = urllib2.urlopen(req)
             except urllib2.HTTPError as response:
-                if response.getcode() in (400, 403):
-                    ## 400 and 403 are the possible returns for api requests
-                    ## on a private branch without authentication.
+                code = response.getcode()
+                if code in (400, 401, 403):
+                    # 400, 401, and 403 are the possible returns for api
+                    # requests on a private branch without authentication.
                     self.log.info("Branch is private")
                     private = True
                 self.log.info(
                     "Branch state not determined; api error, return code: %s",
-                    response.getcode())
+                    code)
+                response.close()
             else:
                 self.log.info("Branch is public")
+                response.close()
 
             try:
                 bzr_branch = safe_open(

